diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 1f6cfda0a..a12f7f9d2 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -32,6 +32,8 @@ import net.minecraft.client.gui.server.ScreenSelectServer;
 import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.player.controller.PlayerControllerSP;
+import net.minecraft.client.render.EntityRendererDispatcher;
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.renderer.CompareFunc;
 import net.minecraft.client.render.renderer.CullFace;
 import net.minecraft.client.render.renderer.GLRenderer;
@@ -91,6 +93,7 @@ import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.LoggedPrintStream;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.save.SaveFormatBase;
 import net.minecraft.core.world.settings.WorldConfiguration;
 import net.minecraft.core.world.type.WorldType;
@@ -218,7 +221,7 @@ public class Minecraft
     public static boolean doPartialTick = true;
     public static EnumGPUVendor GPU_VENDOR = EnumGPUVendor.UNKNOWN;
     private static @NotNull Minecraft INSTANCE;
-    public PlayerController playerController;
+    public @Nullable PlayerController playerController = null;
     public boolean hasCrashed;
     public UnexpectedThrowable lastCrash;
     public final Timer timer;
@@ -280,7 +283,7 @@ public class Minecraft
     public final ScreenshotHelper screenshotHelper = new ScreenshotHelper(this);
     private boolean f3Press = false;
     public Thread rpcThread = null;
-    public PostProcessingManager ppm = new PostProcessingManager(this);
+    public final @NotNull PostProcessingManager ppm = new PostProcessingManager(this);
     private long lastFocusTime;
     public @NotNull GameWindow gameWindow;
     public ClientSkinVariantList skinVariantList = new ClientSkinVariantList(this);
@@ -1226,24 +1229,24 @@ public class Minecraft
         }
     }
 
-    private void mineBlocks(int mouseButton, boolean leftClickDown) {
-        if (leftClickDown && this.objectMouseOver != null && this.objectMouseOver instanceof HitResult.Tile hitTile && mouseButton == 0) {
-            int blockX = hitTile.tilePos.x();
-            int blockY = hitTile.tilePos.y();
-            int blockZ = hitTile.tilePos.z();
-            Side side = hitTile.side;
-            double xPlaced;
-            double yPlaced = hitTile.location.y() - hitTile.tilePos.y();
-            if (side.getAxis() == Axis.X) {
+    private void mineBlocks(final boolean leftClickDown) {
+        final @NotNull PlayerController playerController = Objects.requireNonNull(this.playerController);
+
+        if (leftClickDown && this.objectMouseOver instanceof final @NotNull HitResult.Tile hitTile) {
+            final double xPlaced;
+            if (hitTile.side.getAxis() == Axis.X) {
                 xPlaced = hitTile.location.x() - hitTile.tilePos.x();
-            } else if (side.getAxis() == Axis.Z) {
+            } else if (hitTile.side.getAxis() == Axis.Z) {
                 xPlaced = hitTile.location.z() - hitTile.tilePos.z();
             } else {
                 xPlaced = hitTile.location.x() - hitTile.tilePos.x();
             }
-            this.playerController.continueDestroyBlock(blockX, blockY, blockZ, hitTile.side, xPlaced, yPlaced);
+
+            final double yPlaced = hitTile.location.y() - hitTile.tilePos.y();
+
+            playerController.continueDestroyBlock(hitTile.tilePos, hitTile.side, xPlaced, yPlaced);
         } else {
-            this.playerController.stopDestroyBlock(leftClickDown);
+            playerController.stopDestroyBlock();
         }
     }
 
@@ -1266,9 +1269,11 @@ public class Minecraft
                     if (cube == null) {
                         break bridge;
                     }
-                    int blockX = MathHelper.floor(this.thePlayer.x);
-                    int blockY = MathHelper.floor(this.thePlayer.y - this.thePlayer.heightOffset - 0.25);
-                    int blockZ = MathHelper.floor(this.thePlayer.z);
+                    final @NotNull TilePos tilePos = new TilePos(
+                        MathHelper.floor(this.thePlayer.x),
+                        MathHelper.floor(this.thePlayer.y - this.thePlayer.heightOffset - 0.25),
+                        MathHelper.floor(this.thePlayer.z)
+                    );
 
                     Direction playerDirection = Direction.getHorizontalDirection(this.thePlayer);
                     if (playerDirection.isVertical()) break bridge;
@@ -1281,11 +1286,11 @@ public class Minecraft
                     if (stack == null) {
                         break bridge;
                     }
-                    if (this.playerController.placeItemStackOnTile(this.thePlayer, this.currentWorld, stack, blockX, blockY, blockZ, side, xPlaced, yPlaced)) {
+                    if (this.playerController.placeItemStackOnTile(this.thePlayer, this.currentWorld, stack, tilePos, side, xPlaced, yPlaced)) {
                         this.playerController.swingItem(true);
                     }
                     if (stack.stackSize <= 0) {
-                        this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.getCurrentSlot()] = null;
+                        this.thePlayer.inventory.setCurrentItem(null);
                     } else if (stack.stackSize != numItemsInStack) {
                         this.worldRenderer.itemRenderer.updateEquippedItem();
                     }
@@ -1305,29 +1310,25 @@ public class Minecraft
                 }
             }
         } else if (this.objectMouseOver instanceof HitResult.Tile hitTile) {
-            int blockX = hitTile.tilePos.x();
-            int blockY = hitTile.tilePos.y();
-            int blockZ = hitTile.tilePos.z();
-            Side side = hitTile.side;
             double xPlaced;
             double yPlaced = hitTile.location.y() - hitTile.tilePos.y();
-            if (side.getAxis() == Axis.X) {
+            if (hitTile.side.getAxis() == Axis.X) {
                 xPlaced = hitTile.location.x() - hitTile.tilePos.x();
-            } else if (side.getAxis() == Axis.Z) {
+            } else if (hitTile.side.getAxis() == Axis.Z) {
                 xPlaced = hitTile.location.z() - hitTile.tilePos.z();
             } else {
                 xPlaced = hitTile.location.x() - hitTile.tilePos.x();
             }
 
             if (clickType == 0) {
-                this.playerController.startDestroyBlock(blockX, blockY, blockZ, hitTile.side, xPlaced, yPlaced, repeat);
+                this.playerController.startDestroyBlock(hitTile.tilePos, hitTile.side, xPlaced, yPlaced, repeat);
                 if (this.thePlayer.getHeldObject() == null) {
                     this.playerController.swingItem(true);
                 }
             } else {
                 ItemStack stack = this.thePlayer.inventory.getCurrentItem();
                 int numItemsInStack = stack == null ? 0 : stack.stackSize;
-                if (this.playerController.useOrPlaceItemStackOnTile(this.thePlayer, this.currentWorld, stack, blockX, blockY, blockZ, side, xPlaced, yPlaced)) {
+                if (this.playerController.useOrPlaceItemStackOnTile(this.thePlayer, this.currentWorld, stack, hitTile.tilePos, hitTile.side, xPlaced, yPlaced)) {
                     flag = false;
                     this.playerController.swingItem(true);
                 }
@@ -1611,7 +1612,7 @@ public class Minecraft
                 if (placeBlockPressed && (float) (this.ticksRan - this.mouseTicksRan) >= this.timer.ticksPerSecond / 5F && this.inGameHasFocus)
                     clickMouse(1, this.gameSettings.autoHit.value, true);
             }
-            mineBlocks(0, this.currentScreen == null && breakBlockPressed && this.inGameHasFocus);
+            mineBlocks(this.currentScreen == null && breakBlockPressed && this.inGameHasFocus);
         }
         InputHandler.poll();
         if (this.controllerInput != null) {
@@ -2203,7 +2204,6 @@ public class Minecraft
             Colorizers.update(true);
         }
         if (world != null) {
-            this.playerController.initWorld(world);
             if (!isMultiplayerWorld()) {
                 if (player == null) {
                     this.thePlayer = null;
@@ -2218,13 +2218,11 @@ public class Minecraft
             if (this.thePlayer == null) {
                 this.thePlayer = (PlayerLocal) this.playerController.createPlayer(world);
                 this.thePlayer.resetPos();
-                this.playerController.initPlayer(this.thePlayer);
             }
             this.thePlayer.input = new PlayerInput(this);
             if (this.particleEngine != null) {
                 this.particleEngine.setWorld(world);
             }
-            this.playerController.adjustPlayer(this.thePlayer);
             IChunkProvider ichunkprovider = world.getChunkProvider();
             int i = MathHelper.floor_float((int) this.thePlayer.x) >> 4;
             int j = MathHelper.floor_float((int) this.thePlayer.z) >> 4;
@@ -2247,6 +2245,12 @@ public class Minecraft
             this.loadingScreen.progressStop();
         }
         this.worldRenderer.lightmapHelper.setup();
+
+        Colorizers.reload();
+        BlockColorDispatcher.getInstance().onWorldChanged(this.currentWorld);
+        EntityRendererDispatcher.instance.onWorldChanged(this.currentWorld);
+        TileEntityRenderDispatcher.instance.onWorldChanged(this.currentWorld);
+        BlockModelDispatcher.getInstance().onWorldChanged(this.currentWorld);
     }
 
     private void convertSaveVersion(int fromVersion, String worldDirName) {
@@ -2403,12 +2407,10 @@ public class Minecraft
             this.thePlayer.moveTo((float) bedSpawnCoordinates.x + 0.5F, (float) bedSpawnCoordinates.y + 0.1F, (float) bedSpawnCoordinates.z + 0.5F, 0.0F, 0.0F);
         }
         this.thePlayer.setLastDeathPoint(lastDeathCoordinates);
-        this.playerController.initPlayer(this.thePlayer);
         this.currentWorld.spawnPlayerWithLoadedChunks(this.thePlayer, true);
         this.thePlayer.input = new PlayerInput(this);
         this.thePlayer.id = j;
         this.thePlayer.animate4();
-        this.playerController.adjustPlayer(this.thePlayer);
         prepareLevel("Respawning");
         if (this.currentScreen instanceof ScreenGameOver) {
             displayScreen(null);
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 522cbf632..edfbae4ec 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -103,10 +103,10 @@ public class PlayerLocal extends Player {
         this.gamemode = gamemode;
 
         MenuInventory newContainer = gamemode.getInventoryMenu(this.inventory);
-        if (this.craftingInventory == this.inventorySlots) {
-            this.craftingInventory = newContainer;
+        if (this.containerMenu == this.inventoryMenu) {
+            this.containerMenu = newContainer;
         }
-        this.inventorySlots = newContainer;
+        this.inventoryMenu = newContainer;
         if (!gamemode.hasPlayerFlight()) {
             this.noPhysics = false;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
index 7346f5a25..9d7e0ed5e 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
@@ -3,7 +3,6 @@ package net.minecraft.client.entity.player;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.guidebook.ScreenGuidebook;
 import net.minecraft.client.net.handler.PacketHandlerClient;
-import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
@@ -182,7 +181,7 @@ public class PlayerLocalMultiplayer extends PlayerLocal implements Player.Player
     @Override
 	public void updateCreativeInventory(int page, String searchText)
     {
-    	sendQueue.addToSendQueue(new PacketUpdateCreativeInventory(craftingInventory.containerId, page, searchText));
+    	sendQueue.addToSendQueue(new PacketUpdateCreativeInventory(containerMenu.containerId, page, searchText));
     }
 
     @Override
@@ -222,7 +221,7 @@ public class PlayerLocalMultiplayer extends PlayerLocal implements Player.Player
     @Override
 	public void closeScreen()
     {
-        sendQueue.addToSendQueue(new PacketContainerClose(craftingInventory.containerId));
+        sendQueue.addToSendQueue(new PacketContainerClose(containerMenu.containerId));
         inventory.setHeldItemStack(null);
         super.closeScreen();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Gui.java b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
index 501e00cbe..8d99fbaa7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
@@ -203,15 +203,19 @@ public class Gui {
     }
 
     public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height) {
-        final float uScale = 0.00390625F;
-        final float vScale = 0.00390625F;
         final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
+        addTexturedModalRect(tessellator, x, y, u, v, width, height);
+        tessellator.draw();
+    }
+
+    public void addTexturedModalRect(@NotNull TessellatorGeneral tessellator, final int x, final int y, final int u, final int v, final int width, final int height) {
+        final float uScale = 0.00390625F;
+        final float vScale = 0.00390625F;
         tessellator.addVertexWithUV(x, y + height, this.zLevel, (u) * uScale, (v + height) * vScale);
         tessellator.addVertexWithUV(x + width, y + height, this.zLevel, (u + width) * uScale, (v + height) * vScale);
         tessellator.addVertexWithUV(x + width, y, this.zLevel, (u + width) * uScale, (v) * vScale);
         tessellator.addVertexWithUV(x, y, this.zLevel, (u) * uScale, (v) * vScale);
-        tessellator.draw();
     }
 
     public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height, final double uScale, final double vScale) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index 6ad285d9e..d44c7b9e0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -28,6 +28,7 @@ import net.minecraft.client.render.renderer.CullFace;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.helper.UrlHelper;
 import net.minecraft.core.Version;
@@ -344,7 +345,7 @@ public class ScreenMainMenu extends Screen {
         }
 
         GLRenderer.pushFrame();
-        GLRenderer.setShader(Shaders.WORLD);
+        GLRenderer.setShader(Shaders.TERRAIN);
         final int delta = this.mc.gameWindow.getWidthPixels() / this.mc.resolution.getScaledWidthScreenCoords();
         int var3 = 120 * delta;
         GLRenderer.projectionM4f().identity().perspective(70.0F, (float) this.mc.gameWindow.getWidthPixels() / (float) var3, 0.05F, 100.0F);
@@ -384,6 +385,11 @@ public class ScreenMainMenu extends Screen {
             GLRenderer.modelM4f().scale(0.89F, 1.0F, 0.4F);
             GLRenderer.modelM4f().translate((float) (-logoBlockLayers[0].length()) * 0.5F, (float) (-logoBlockLayers.length) * 0.5F, 0.0F);
             TextureRegistry.worldAtlas.bind();
+            GL41.glActiveTexture(GL41.GL_TEXTURE2);
+            TextureRegistry.worldAtlas.layerTextureMap.get("emissive").bind();
+//        GL41.glActiveTexture(GL41.GL_TEXTURE3);
+//        TextureRegistry.worldAtlas.layerTextureMap.get("maskColor").bind();
+            GL41.glActiveTexture(GL41.GL_TEXTURE0);
             if (renderPass == 0) {
                 this.mc.textureManager.loadTexture("/title/black.png").bind();
             }
@@ -406,7 +412,8 @@ public class ScreenMainMenu extends Screen {
                         GLRenderer.setColor4f(1f, 1f, 1f, alpha);
                         GLRenderer.modelM4f().translate(x, y, z);
                         GLRenderer.modelM4f().scale(scale, scale, scale);
-                        BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[this.indexToDraw]).renderStandalone(GLRenderer.getTessellator(), 0, LightmapHelper.getLightmapCoord(15, 15));
+                        TessellatorGeneral t = GLRenderer.getTessellator();
+                        BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[this.indexToDraw]).renderStandalone(t, 0, LightmapHelper.getLightmapCoord(15, 15));
                         GLRenderer.popFrame();
                     }
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
index 5016a29bb..8078651e2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
@@ -60,7 +60,7 @@ public class ScreenActivator extends ScreenContainerAbstract {
     }
 
     @Override
-    protected void drawGuiContainerBackgroundLayer(float f) {
+    protected void drawGuiContainerBackgroundLayer(float partialTick) {
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/activator.png").bind();
         int xLeft = (this.width - this.xSize) / 2;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
index 0d4807527..243f7b5da 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
@@ -26,7 +26,7 @@ public class ScreenContainer extends ScreenContainerAbstract {
     }
 
     @Override
-    protected void drawGuiContainerBackgroundLayer(float f) {
+    protected void drawGuiContainerBackgroundLayer(float partialTick) {
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/container.png").bind();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index 4884fd5f0..b2065988a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -56,7 +56,7 @@ public abstract class ScreenContainerAbstract extends Screen {
         return false;
     }
 
-    protected abstract void drawGuiContainerBackgroundLayer(float f);
+    protected abstract void drawGuiContainerBackgroundLayer(float partialTick);
 
     protected void drawGuiContainerForegroundLayer() {
     }
@@ -136,7 +136,7 @@ public abstract class ScreenContainerAbstract extends Screen {
     @Override
     public void init() {
         super.init();
-        this.mc.thePlayer.craftingInventory = this.inventorySlots;
+        this.mc.thePlayer.containerMenu = this.inventorySlots;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
index cb80e9f4e..fd3feb4f8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
@@ -27,7 +27,7 @@ public class ScreenCrafting extends ScreenContainerAbstract {
     }
 
     @Override
-    protected void drawGuiContainerBackgroundLayer(float f) {
+    protected void drawGuiContainerBackgroundLayer(float partialTick) {
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/crafting.png").bind();
         int left = (this.width - this.xSize) / 2;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java
index 32d814db7..27c5669b9 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java
@@ -19,7 +19,7 @@ public class ScreenDispenser extends ScreenContainerAbstract {
     }
 
     @Override
-    protected void drawGuiContainerBackgroundLayer(float f) {
+    protected void drawGuiContainerBackgroundLayer(float partialTick) {
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/dispenser.png").bind();
         int left = (this.width - this.xSize) / 2;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
index 26727e541..2bccb5377 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
@@ -320,7 +320,7 @@ public class ScreenFlagEditor
     }
 
     @Override
-    protected void drawGuiContainerBackgroundLayer(float f) {
+    protected void drawGuiContainerBackgroundLayer(float partialTick) {
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/flag_editor.png").bind();
         int j = (this.width - this.xSize) / 2;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
index ebb468b32..8cbfdd594 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
@@ -23,7 +23,7 @@ public class ScreenFurnace extends ScreenContainerAbstract {
     }
 
     @Override
-    protected void drawGuiContainerBackgroundLayer(float f) {
+    protected void drawGuiContainerBackgroundLayer(float partialTick) {
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/furnace.png").bind();
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         int x = (this.width - this.xSize) / 2;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java
index 2eb8e39e0..18c57aa22 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java
@@ -26,7 +26,7 @@ public class ScreenFurnaceBlast
     }
 
     @Override
-    protected void drawGuiContainerBackgroundLayer(final float f) {
+    protected void drawGuiContainerBackgroundLayer(final float partialTick) {
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/blastfurnace.png").bind();
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         final int x = (this.width - this.xSize) / 2;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
index eeec84b0b..d8f26f94f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
@@ -11,6 +11,7 @@ import net.minecraft.client.render.entity.EntityRenderer;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.player.Player;
@@ -42,7 +43,7 @@ public class ScreenInventory extends ScreenContainerAbstract {
 
 
     public ScreenInventory(Player player) {
-        super(player.inventorySlots);
+        super(player.inventoryMenu);
         this.passEvents = true;
         player.addStat(Achievements.OPEN_INVENTORY, 1);
     }
@@ -165,13 +166,16 @@ public class ScreenInventory extends ScreenContainerAbstract {
             }
         }
 
+        TessellatorGeneral t = GLRenderer.getTessellator();
+        t.startDrawingQuads();
         for (int i = 0; i < this.overlayButtonsLayout.elements.size(); i++) {
             OverlayButtonElement<?> button = (OverlayButtonElement<?>) this.overlayButtonsLayout.elements.get(i);
-            drawTexturedModalRect(button.xPosition + 1, button.yPosition + 1, 176, 9 + 9 * this.uvs.getInt(i), 9, 9);
+            addTexturedModalRect(t, button.xPosition + 1, button.yPosition + 1, 176, 9 + 9 * this.uvs.getInt(i), 9, 9);
             boolean val = true;
             if (button.option instanceof OptionBoolean) val = (Boolean) button.option.value;
-            if (!val) drawTexturedModalRect(button.xPosition + 1, button.yPosition + 1, 194, 0, 9, 9);
+            if (!val) addTexturedModalRect(t, button.xPosition + 1, button.yPosition + 1, 194, 0, 9, 9);
         }
+        t.draw();
 
         for (int i = 0; i < this.overlayButtonsLayout.elements.size(); i++) {
             OverlayButtonElement<?> button = (OverlayButtonElement<?>) this.overlayButtonsLayout.elements.get(i);
@@ -245,44 +249,49 @@ public class ScreenInventory extends ScreenContainerAbstract {
     }
 
     @Override
-    protected void drawGuiContainerBackgroundLayer(float f) {
+    protected void drawGuiContainerBackgroundLayer(float partialTick) {
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/inventory.png").bind();
-        int j = (this.width - this.xSize) / 2;
-        int k = (this.height - this.ySize) / 2;
-        drawTexturedModalRect(j, k, 0, 0, this.xSize, this.ySize);
+        int x = (this.width - this.xSize) / 2;
+        int y = (this.height - this.ySize) / 2;
+        drawTexturedModalRect(x, y, 0, 0, this.xSize, this.ySize);
 
         GLRenderer.pushFrame();
         GLRenderer.setShader(Shaders.WORLD);
         GLRenderer.getFogState().disable();
         GLRenderer.enableState(State.DEPTH_TEST);
-        GLRenderer.modelM4f().translate(j + 51, k + 75, 50F);
+        GLRenderer.modelM4f().translate(x + 51, y + 75, 50F);
         float f1 = 30F;
         GLRenderer.modelM4f().scale(-f1, f1, f1);
         GLRenderer.modelM4f().rotateZ(org.joml.Math.toRadians(180F));
-        float f2 = this.mc.thePlayer.yBodyRot;
-        float f3 = this.mc.thePlayer.yRot;
-        float f4 = this.mc.thePlayer.xRot;
-        float f5 = (float) (j + 51) - this.xSize_lo;
-        float f6 = (float) ((k + 75) - 50) - this.ySize_lo;
+        float yBodyRot = this.mc.thePlayer.yBodyRot;
+        float yBodyRotO = this.mc.thePlayer.yBodyRotO;
+        float yRot = this.mc.thePlayer.yRot;
+        float yRotO = this.mc.thePlayer.yRotO;
+        float xRot = this.mc.thePlayer.xRot;
+        float xRotO = this.mc.thePlayer.xRotO;
+        float eyesX = (float) (x + 51) - this.xSize_lo;
+        float eyesY = (float) ((y + 75) - 50) - this.ySize_lo;
         GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(135F));
         Lighting.enableLight();
         GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(-135F));
-        GLRenderer.modelM4f().rotateX(org.joml.Math.toRadians(-(float) Math.atan(f6 / 40F) * 20F));
-        this.mc.thePlayer.yBodyRot = (float) Math.atan(f5 / 40F) * 20F;
-        this.mc.thePlayer.yRot = (float) Math.atan(f5 / 40F) * 40F;
-        this.mc.thePlayer.xRot = -(float) Math.atan(f6 / 40F) * 20F;
-        this.mc.thePlayer.entityBrightness = 1.0F;
+        GLRenderer.modelM4f().rotateX(org.joml.Math.toRadians(-(float) Math.atan(eyesY / 40F) * 20F));
+        this.mc.thePlayer.yBodyRotO = this.mc.thePlayer.yBodyRot = (float) Math.atan(eyesX / 40F) * 20F;
+        this.mc.thePlayer.yRotO = this.mc.thePlayer.yRot = (float) Math.atan(eyesX / 40F) * 40F;
+        this.mc.thePlayer.xRotO = this.mc.thePlayer.xRot = -(float) Math.atan(eyesY / 40F) * 20F;
         GLRenderer.modelM4f().translate(0.0F, this.mc.thePlayer.heightOffset, 0.0F);
         EntityRendererDispatcher.instance.viewLerpYaw = 180F;
         EntityRenderer.renderShadows = false;
         GLRenderer.globalGetNormalTransformMatrix().scale(1, -1, 1);
-        EntityRendererDispatcher.instance.renderEntityPreviewWithPosYaw(GLRenderer.getTessellator(), this.mc.thePlayer, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
+        GLRenderer.setLightmapCoord2i(15, 15);
+        EntityRendererDispatcher.instance.renderEntityPreviewWithPosYaw(GLRenderer.getTessellator(), this.mc.thePlayer, 0.0D, 0.0D, 0.0D, 0.0F, partialTick);
         EntityRenderer.renderShadows = true;
-        this.mc.thePlayer.entityBrightness = 0.0F;
-        this.mc.thePlayer.yBodyRot = f2;
-        this.mc.thePlayer.yRot = f3;
-        this.mc.thePlayer.xRot = f4;
+        this.mc.thePlayer.yBodyRot = yBodyRot;
+        this.mc.thePlayer.yBodyRotO = yBodyRotO;
+        this.mc.thePlayer.yRot = yRot;
+        this.mc.thePlayer.yRotO = yRotO;
+        this.mc.thePlayer.xRot = xRot;
+        this.mc.thePlayer.xRotO = xRotO;
         GLRenderer.popFrame();
         Lighting.disable();
     }
